/* GCC */

#include <fstream>
#include <sstream>
#include <vector>
#include <algorithm>

using namespace std;

struct Progression
{
    long A, D, N;
    Progression(long a, long d, long n) : A(a), D(d), N(n) {}
};

int N;
vector<long> nums;
vector<Progression> answers;
vector<Progression> used;
int ansN = 0;

inline void Input()
{
    stringstream ss;
    ifstream fin("sequence.in");
    ss<<fin.rdbuf();
    fin.close();

    ss>>N;
    nums.resize(N);

    for(int i = 0; i < N; i++)
        ss>>nums[i];
}

inline void findProg(int begin, long d)
{
    long expected = nums[begin] + d;
    long n = 1;

    for(int i = begin + 1; ;i++)
    {
        if(nums[i] > expected)
            break;
        else if(nums[i] == expected)
        {
            n++;
            expected += d;
        }
    }

    if(n > ansN)
    {
        answers.clear();
    }
    if(n >= ansN)
    {
        answers.push_back(Progression(nums[begin], d, n));
        ansN = n;
    }
}

int main()
{
    Input();

    sort(nums.begin(), nums.end());

    for(int i = 0; i < N - 1 && ansN <= N-i; i++)
    {
        for(int j = i + 1; j < N; j++)
        {
            findProg(i, nums[j] - nums[i]);
        }
    }

    ostringstream oss;
    for(int i = 0; i < answers.size(); i++)
    {
        oss<<answers[i].N<<' '<<answers[i].A<<' '<<answers[i].D<<endl;
    }
    ofstream fout("sequence.out");
    fout<<oss.str();
    fout.close();

    return 0;
}
